package anywheresoftware.b4a.table;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.table", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.table", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.http.HttpClientWrapper _httpclient1 = null;
public static anywheresoftware.b4a.objects.StringUtils _strencode = null;
public static String _strsql = "";
public table _table1 = null;
public table _table2 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 11;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 13;BA.debugLine="HttpClient1.Initialize(\"HttpClient1\")";
_httpclient1.Initialize("HttpClient1");
 //BA.debugLineNum = 15;BA.debugLine="StrSql = \"Select CCode,CName,Country,ShrtName from Customer Order by CCode\"";
_strsql = "Select CCode,CName,Country,ShrtName from Customer Order by CCode";
 //BA.debugLineNum = 16;BA.debugLine="StrSql = StrEnCode.EncodeUrl(StrSql,\"UTF8\")";
_strsql = _strencode.EncodeUrl(_strsql,"UTF8");
 //BA.debugLineNum = 17;BA.debugLine="LoadGrid(StrSql)";
_loadgrid(_strsql);
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 7;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 8;BA.debugLine="Dim Table1, Table2 As Table";
mostCurrent._table1 = new table();
mostCurrent._table2 = new table();
 //BA.debugLineNum = 9;BA.debugLine="End Sub";
return "";
}
public static String  _httpclient1_responseerror(String _reason,int _statuscode,int _taskid) throws Exception{
String _msg = "";
 //BA.debugLineNum = 95;BA.debugLine="Sub HttpClient1_ResponseError (Reason As String, StatusCode As Int, TaskId As Int)";
 //BA.debugLineNum = 97;BA.debugLine="Log(Reason)";
anywheresoftware.b4a.keywords.Common.Log(_reason);
 //BA.debugLineNum = 98;BA.debugLine="Log(StatusCode)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_statuscode));
 //BA.debugLineNum = 99;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 100;BA.debugLine="msg = \"Error connecting to server.\"";
_msg = "Error connecting to server.";
 //BA.debugLineNum = 101;BA.debugLine="If Reason <> Null Then msg = msg & CRLF & Reason";
if (_reason!= null) { 
_msg = _msg+anywheresoftware.b4a.keywords.Common.CRLF+_reason;};
 //BA.debugLineNum = 102;BA.debugLine="ToastMessageShow (msg, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_msg,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 104;BA.debugLine="End Sub";
return "";
}
public static String  _httpclient1_responsesuccess(anywheresoftware.b4a.http.HttpClientWrapper.HttpResponeWrapper _response,int _taskid) throws Exception{
String _result = "";
String _s = "";
String[] _rows = null;
String[] _cols = null;
anywheresoftware.b4a.objects.collections.List _header = null;
int _j = 0;
int _i = 0;
String[] _theader = null;
String[] _record = null;
int[] _cwidth = null;
 //BA.debugLineNum = 42;BA.debugLine="Sub HttpClient1_ResponseSuccess (Response As HttpResponse, TaskId As Int)";
 //BA.debugLineNum = 45;BA.debugLine="Log(\"ResponseSuccess\")";
anywheresoftware.b4a.keywords.Common.Log("ResponseSuccess");
 //BA.debugLineNum = 46;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 47;BA.debugLine="Dim result As String";
_result = "";
 //BA.debugLineNum = 48;BA.debugLine="Dim s As String";
_s = "";
 //BA.debugLineNum = 49;BA.debugLine="Dim Rows() As String";
_rows = new String[(int)(0)];
java.util.Arrays.fill(_rows,"");
 //BA.debugLineNum = 50;BA.debugLine="Dim Cols() As String";
_cols = new String[(int)(0)];
java.util.Arrays.fill(_cols,"");
 //BA.debugLineNum = 51;BA.debugLine="Dim Header As List";
_header = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 52;BA.debugLine="Dim J As Int";
_j = 0;
 //BA.debugLineNum = 53;BA.debugLine="result = Response.GetString(\"UTF8\") 'Convert the response to a string";
_result = _response.GetString("UTF8");
 //BA.debugLineNum = 54;BA.debugLine="s = result";
_s = _result;
 //BA.debugLineNum = 55;BA.debugLine="Rows = Regex.Split(\"[|]\", s)";
_rows = anywheresoftware.b4a.keywords.Common.Regex.Split("[|]",_s);
 //BA.debugLineNum = 57;BA.debugLine="For i = 0 To Rows.Length - 1";
{
final double step39 = 1;
final double limit39 = (int)(_rows.length-1);
for (_i = (int)(0); (step39 > 0 && _i <= limit39) || (step39 < 0 && _i >= limit39); _i += step39) {
 //BA.debugLineNum = 58;BA.debugLine="Cols = Regex.Split(\"[*]\", Rows(i))";
_cols = anywheresoftware.b4a.keywords.Common.Regex.Split("[*]",_rows[_i]);
 //BA.debugLineNum = 59;BA.debugLine="If i = 0 Then '--------------------------------------> ' Return No of Columns";
if (_i==0) { 
 //BA.debugLineNum = 60;BA.debugLine="Dim tHeader(Cols(i)) As String";
_theader = new String[(int)(Double.parseDouble(_cols[_i]))];
java.util.Arrays.fill(_theader,"");
 //BA.debugLineNum = 61;BA.debugLine="Dim Record(Cols(i)) As String";
_record = new String[(int)(Double.parseDouble(_cols[_i]))];
java.util.Arrays.fill(_record,"");
 //BA.debugLineNum = 62;BA.debugLine="Dim cWidth(Cols(i)) As Int";
_cwidth = new int[(int)(Double.parseDouble(_cols[_i]))];
;
 //BA.debugLineNum = 63;BA.debugLine="Table1.Initialize(Me, \"Table1\", Cols(i),0,True)";
mostCurrent._table1._initialize(mostCurrent.activityBA,main.getObject(),"Table1",(int)(Double.parseDouble(_cols[_i])),(int)(0),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 64;BA.debugLine="Table1.AddToActivity(Activity, 0, 0dip, 100%x, 100%y)";
mostCurrent._table1._addtoactivity(mostCurrent._activity,(int)(0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 //BA.debugLineNum = 65;BA.debugLine="Table1.ClearAll";
mostCurrent._table1._clearall();
 }else if(_i==1) { 
 //BA.debugLineNum = 67;BA.debugLine="For J = 0 To Cols.Length - 1";
{
final double step49 = 1;
final double limit49 = (int)(_cols.length-1);
for (_j = (int)(0); (step49 > 0 && _j <= limit49) || (step49 < 0 && _j >= limit49); _j += step49) {
 //BA.debugLineNum = 68;BA.debugLine="tHeader(J) = Cols(J)";
_theader[_j] = _cols[_j];
 }
};
 //BA.debugLineNum = 70;BA.debugLine="Table1.SetHeader(tHeader)";
mostCurrent._table1._setheader(_theader);
 }else if(_i==2) { 
 //BA.debugLineNum = 72;BA.debugLine="For J = 0 To Cols.Length - 1";
{
final double step54 = 1;
final double limit54 = (int)(_cols.length-1);
for (_j = (int)(0); (step54 > 0 && _j <= limit54) || (step54 < 0 && _j >= limit54); _j += step54) {
 //BA.debugLineNum = 73;BA.debugLine="If Cols(J) = 135 Then";
if ((_cols[_j]).equals(BA.NumberToString(135))) { 
 //BA.debugLineNum = 74;BA.debugLine="cWidth(J)  = 80dip";
_cwidth[_j] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80));
 }else if((_cols[_j]).equals(BA.NumberToString(200))) { 
 //BA.debugLineNum = 76;BA.debugLine="cWidth(J)  = 120dip";
_cwidth[_j] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(120));
 }else {
 //BA.debugLineNum = 78;BA.debugLine="cWidth(J)  = 65dip";
_cwidth[_j] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(65));
 };
 }
};
 }else {
 //BA.debugLineNum = 82;BA.debugLine="For J = 0 To Cols.Length - 1 '----------------------------------> ' Adding Rows";
{
final double step64 = 1;
final double limit64 = (int)(_cols.length-1);
for (_j = (int)(0); (step64 > 0 && _j <= limit64) || (step64 < 0 && _j >= limit64); _j += step64) {
 //BA.debugLineNum = 83;BA.debugLine="Record(J) = Cols(J)";
_record[_j] = _cols[_j];
 }
};
 //BA.debugLineNum = 85;BA.debugLine="Table1.AddRow(Record)";
mostCurrent._table1._addrow(_record);
 };
 }
};
 //BA.debugLineNum = 88;BA.debugLine="Table1.SetColumnsWidths(cWidth)";
mostCurrent._table1._setcolumnswidths(_cwidth);
 //BA.debugLineNum = 94;BA.debugLine="End Sub";
return "";
}
public static String  _loadgrid(String _query) throws Exception{
anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper _request1 = null;
String _url1 = "";
 //BA.debugLineNum = 31;BA.debugLine="Sub LoadGrid(Query As String)";
 //BA.debugLineNum = 33;BA.debugLine="Dim request1 As HttpRequest";
_request1 = new anywheresoftware.b4a.http.HttpClientWrapper.HttpUriRequestWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Dim URL1 As String";
_url1 = "";
 //BA.debugLineNum = 35;BA.debugLine="URL1 =   \"http://14.102.90.6/RemoteDB/ShowGridNew.asp?Param=\"&Query";
_url1 = "http://14.102.90.6/RemoteDB/ShowGridNew.asp?Param="+_query;
 //BA.debugLineNum = 36;BA.debugLine="request1.InitializeGet(URL1)";
_request1.InitializeGet(_url1);
 //BA.debugLineNum = 37;BA.debugLine="request1.Timeout = 10000 'set timeout to 10 seconds";
_request1.setTimeout((int)(10000));
 //BA.debugLineNum = 38;BA.debugLine="If HttpClient1.Execute(request1, 1) = False Then Return 'Will be false if their is already a running task (with the same id).";
if (_httpclient1.Execute(processBA,_request1,(int)(1))==anywheresoftware.b4a.keywords.Common.False) { 
if (true) return "";};
 //BA.debugLineNum = 39;BA.debugLine="ProgressDialogShow(\"Calling KHARIND server...\")";
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Calling KHARIND server...");
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 2;BA.debugLine="Dim HttpClient1 As HttpClient";
_httpclient1 = new anywheresoftware.b4a.http.HttpClientWrapper();
 //BA.debugLineNum = 3;BA.debugLine="Dim StrEnCode As StringUtils";
_strencode = new anywheresoftware.b4a.objects.StringUtils();
 //BA.debugLineNum = 4;BA.debugLine="Dim StrSql As String";
_strsql = "";
 //BA.debugLineNum = 5;BA.debugLine="End Sub";
return "";
}
}
